竞赛
考级
这会的的欢乐赛有点离谱, 简直是·水题啊 第one道: 其实这道题很简单,用set或map都行(包括去重) 第tow道: 第一眼看到这题,我竟然第一下想到了“dfs” 啊啊啊啊啊啊啊啊啊啊啊啊 精神状态良好) 第three道: 这道题其实是一道思维题 我想了半天,最终推出来时“n/3−2n/3-2n/3−2”(so 我还想怎么能在欢乐赛出这种题呢??? 第four道: 这道题本来想用埃式筛的,结果一看数据,普通晒垡完全够。 第five道: 没啥可讲的,sort即可 第six道: 不想讲
There is something wrong with the CF, please try again later
循环的嵌套
#include<iostream> using namespace std; int main(){ char a; cin>>a; if(int(a)<90){ cout << int(a)-64; }else{ cout << int(a)-96; } }
#include<iostream> using namespace std; int main(){ int n; cin>>n; if(n%2==0){ cout<<"even"; } else{ cout<<"odd"; } return 0; }
函数 类
洛谷能过 > ACGO就不能
蒙特卡洛方法计算π的近似值 因为用的是随机值 所以结果会有点不同 时间复杂度:O(100,000,000) 空间复杂度:O(1) 看到就点个赞吧(bushi
#include<bits/stdc++.h> using namespace std; int a[1010]; int n; int binary(int a[],int target){ int l=1,r=n; } int main(){ int x; scanf("%d",&n); for(int i=1;i<=n;i++){ scanf("%d",&a[i]); }scanf("%d",&x); cout<<binary(a,x); }
T1 0123456背包板子题 dpidp_idpi 表示能否拼成长度为 iii 的钢条,如果 i−ji-ji−j 可以拼而且恰好有一根长度为 jjj 的木条就可以拼 (未完成)
#include<bits/stdc++.h> using namespace std; int main(){ int n,m; cin>>n>>m; int a[1000000]; for(int i=1;i<=n;i++){ cin>>a[i]; } int min=100000,t=0; for(int i=1;i<=n-m+1;i++){ for(int j=1;j<=m;j++) t+=a[i+j-1]; if(t<min) min=t; t=0; } cout<<min; return 0; }
作者亲测可过(不信去看第一次提交)
ACGO欢乐赛#33 T1、换行 T2、求和 T3、权重 T4、因子 T5、美丽数组 T6、字典序问题
2024年9月一级pdf
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ T1: 第一道题,不简单就不是欢乐赛,但是还是有很多新手这一题做不出来。如果直接 只会输出一个换行,正确做法如下: ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ T2: 这题也十分简单,用斐波那契公式求和公式: 但是要注意,因为n最大是INT_MAX,所以记得开long long。 代码如下: ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ T3: 这题的一个高精度符号’∑‘让新手们知难而退,太好了,但是其实说白了就是用每个韵母相对应的出现次数 * W[i],理清思路即可。 代码如下: T4: 我认为这一题是本赛出最后一题以外最难的题。对我来说还是小菜一碟,对于没有接触过查找因数的新手来说容易time limit error。这题用的贪心算法可能对于新手来说也会有一定难度。我来介绍两个版本。 版本一: 根据我用一条命来换的测量,这样做的话会有几个TLE,其实可以优化f函数,把找因数的函数时间复杂度从O(N) 降到O(log N)。 最终AC代码如下: T5: 这题不难,顺着题目的意思来就行了。记得下标不要弄混。 题目代码: T6: 这题我的做法是拼命打补丁(所以死了很多次)。 要注意的有四项: 1.当数字形如xxxx......(x < 9)时,最优解是这个数字的位数-1个9,这是最显而易见的规律。 e.g : n = 53423,ans = 9999。 2.当数字的每一位都是九时,答案就是它本身。 e.g : n = 999,ans = 999。 3.当数字除了最后一位其他都是9时,答案也是它本身。 e.g : n = 9998,ans = 9998。 4.当数字的大部分位都是9,中间的几位<9时,答案是这个数字的位数-1个9。 e.g : n = 9899,ans = 999。 衣衫褴褛的代码如下: 如果这个题解对你有用,希望能点个赞支持一下!
共8960条